#pragma once

#include <d3dx8.h>

class D3DCamera
{
public:
    D3DCamera(void);
    ~D3DCamera(void);

    bool create(IDirect3DDevice8 * pd3dDevice);

    void forward(void)   { m_vEye += m_vLook;  }
    void backward(void)  { m_vEye -= m_vLook;  }
    void turnLeft(void)  { m_vEye -= m_vRight; }
    void turnRight(void) { m_vEye += m_vRight; }

    bool updateView(void);

//private:
    IDirect3DDevice8 * m_pd3dDevice;

    D3DXVECTOR3	m_vEye;//(0.0f, 20.0f, 0.0f);  // Camera Position
    D3DXVECTOR3	m_vLook;//(0.0f, 0.0f, 1.0f);  // Camera Look Vector
    D3DXVECTOR3	m_vUp;//(0.0f, 1.0f, 0.0f);    // Camera Up Vector
    D3DXVECTOR3	m_vRight;//(1.0f, 0.0f, 0.0f); // Camera Right Vector
};
